unit SelArcs;

interface

uses
{$IFDEF WIN32}
  Windows,
{$ELSE}
  WinTypes, WinProcs,
{$ENDIF}
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, FileCtrl, Compress, Segment;

type
  TSelArcsForm = class(TForm)
    DCB: TDriveComboBox;
    DLB: TDirectoryListBox;
    FLB: TFileListBox;
    CloseBtn: TBitBtn;
    LBGroup: TGroupBox;
    LB: TListBox;
    FileCnt: TLabel;
    SelBtn: TBitBtn;
    EFilter: TEdit;
    ERecurse: TCheckBox;
    RestBtn: TBitBtn;
    procedure CloseBtnClick(Sender: TObject);
    procedure EFilterExit(Sender: TObject);
    procedure SelBtnClick(Sender: TObject);
    procedure LBKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DCBChange(Sender: TObject);
    procedure DoKeyPress(Sender: TObject; var Key: Char);
    procedure ERecurseClick(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
  private
    { Private declarations }
    procedure SetLBCount;
    procedure UpdateLB;
  public
    { Public declarations }
    procedure SelectArcs( SL: TstringList );
  end;

var
  SelArcsForm: TSelArcsForm;

implementation

uses Main, Common;

{$R *.DFM}
var
  TLB:    TStringList;

{===============================================================}
{===============================================================}
procedure TSelArcsForm.SelectArcs( SL: TStringList );
var
  CurDir:        String;
  Seq:           Integer;
  i:             Integer;
begin
     TLB := TStringList.Create;
     LB.Clear;
     SetLBCount;
     GetDir(0,CurDir);
     DLB.Directory := CurDir;
     EFilter.Text := FLB.Mask;
     if (MainForm.SegCompEZ.SegBuildMode = bmFlat) then
       ERecurse.State := cbUnChecked
     else
       ERecurse.State := cbChecked;
     FTarget := MakeTarget(LowerCase(FLB.Directory));
     ShowModal;
     Seq := 0;
     if (LB.Items.Count > 0) then
       begin
         for i := 0 to LB.Items.Count-1 do
         begin
         SL.Add(LB.Items[i]);
         end;
       end;
     TLB.Free;
end;

{===============================================================}
{===============================================================}
procedure TSelArcsForm.SelBtnClick(Sender: TObject);
begin
     AddUniqueFile(TLB,MakeTarget(FLB.Directory)+EFilter.Text);
     UpdateLB;
end;

{===============================================================}
{===============================================================}
procedure TSelArcsForm.UpdateLB;
var
   i:      Integer;
begin
     LB.Clear;
     for i := 0 to TLB.Count-1 do
       LB.Items.Add(TLB[i]);
     SetLBCount;
end;

{===============================================================}
{===============================================================}
procedure TSelArcsForm.DCBChange(Sender: TObject);
begin
     {Add code}
end;

{===============================================================}
{===============================================================}
procedure TSelArcsForm.ERecurseClick(Sender: TObject);
begin
     if (ERecurse.State = cbChecked) then
       MainForm.SegCompEZ.SegBuildMode := bmRecursive
     else
       MainForm.SegCompEZ.SegBuildMode := bmFlat;
end;

{===============================================================}
{===============================================================}
procedure TSelArcsForm.ResetBtnClick(Sender: TObject);
begin
     TLB.Clear;
     LB.Clear;
     SetLBCount;
end;

{===============================================================}
{===============================================================}
procedure TSelArcsForm.CloseBtnClick(Sender: TObject);
begin
     Close;
end;

{===============================================================}
{===============================================================}
procedure TSelArcsForm.SetLBCount;
begin
     FileCnt.Caption := 'Count: ' + IntToStr(LB.Items.Count);
end;

{===============================================================}
{===============================================================}
procedure TSelArcsForm.EFilterExit(Sender: TObject);
begin
     if (EFilter.Text = '') then
       EFilter.Text := FLB.Mask;
     FLB.Mask := EFilter.Text;
end;

{===============================================================}
{===============================================================}
procedure TSelArcsForm.LBKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
   i:      Integer;
begin
     if (Key = VK_DELETE) then
       begin
       while (LB.SelCount > 0) do
         begin
         for i := 0 to LB.Items.Count-1 do
           begin
           if (LB.Selected[i]) then
             begin
             LB.Items.Delete(i);
             TLB.Delete(i);
             SetLBCount;
             break;
             end;
           end;
         end;
       end;

end;

{===============================================================}
{===============================================================}
procedure TSelArcsForm.DoKeyPress(Sender: TObject; var Key: Char);
begin
     if (Key = #13) then
       begin
       SelectNext(Sender as tWinControl,True,True);
       Key := #0;
       end;
end;

end.
